<?php
// register the custom post type
add_action( 'init', 'wpstream_create_free_products',1 );

function wpstream_create_free_products() {
    
    register_post_type( 'wpstream_product',
            array(
            'labels' => array(
                    'name'          => __( 'Free Live Channel / Free Video','wpestate'),
                    'singular_name' => __( 'Free Live Channel / Free Video','wpestate'),
                    'add_new'       => __('Add New Free Live Channel / Free Video','wpestate'),
            'add_new_item'          =>  __('Add Free Free Live Channel / Free Video','wpestate'),
            'edit'                  =>  __('Edit' ,'wpestate'),
            'edit_item'             =>  __('Edit Free Live Channel / Free Video','wpestate'),
            'new_item'              =>  __('New Free Live Channel / Free Video','wpestate'),
            'view'                  =>  __('View','wpestate'),
            'view_item'             =>  __('View Free Live Channel / Free Video','wpestate'),
            'search_items'          =>  __('Search Free Live Channel / Free Video','wpestate'),
            'not_found'             =>  __('No Free Free Live Channel / Free Video','wpestate'),
            'not_found_in_trash'    =>  __('No Free Free Live Channel / Free Video','wpestate'),
            'parent'                =>  __('Parent Free Live Channel / Free Video','wpestate')
                    ),
            'public' => true,
            'has_archive' => true,
            'rewrite' => array('slug' => 'wpstream'),
            'supports' => array('title', 'editor', 'thumbnail','comments'),
            'can_export' => true,
            'register_meta_box_cb' => 'wpstream_add_product_metaboxes',
            'taxonomies'          => array( 'category','post_tag' ),
            

            )
    );
   


}



 
function wpstream_add_product_metaboxes() {	
    add_meta_box(  'wpstream_add_product_metaboxes-sectionid',
            __( 'Live Channel/Video Settings', 'wpestate' ),'wpstream_free_product','wpstream_product' ,'normal','default'
    );
}




function wpstream_free_product( $post ) {
    wp_nonce_field( plugin_basename( __FILE__ ), 'estate_agent_noncename' );
    global $post;
    $wpstream_product_type =    esc_html(get_post_meta($post->ID, 'wpstream_product_type', true));
    $is_live               =    '';
    $is_video              =    '';
    
    if($wpstream_product_type==1){
        $is_live = ' selected ';
    }
    if($wpstream_product_type==2){
        $is_video = ' selected ';
    }
     
    print'
    <p class="meta-options">
        <label for="wpstream_product_type">'.__('Media Type:','wpestate').' </label><br />
        <select id="wpstream_product_type" name="wpstream_product_type">
            <option value="1" '.$is_live.'>'.__('Free Live Chanel','wpstream').'</option>
            <option value="2" '.$is_video.'>'.__('Free Video','wpstream').'</option>
        </select>
    </p>        
    ';           
    
    
    $wpstream_free_video =    esc_html(get_post_meta($post->ID, 'wpstream_free_video', true));
    print'
    <p class="meta-options video_free">
        <label for="wpstream_free_video">'.__('Chose video:','wpestate').' </label><br />
        <select id="wpstream_free_video" name="wpstream_free_video">';
            $video_list = wpstream_get_videos();
          
            foreach ($video_list as $key=>$value){
                print '<option value="'.$key.'"'; 
                if($wpstream_free_video === $key){
                   print ' selected ';
                }
                print '>'.$value.'</option>';
            }
     print'
        </select>
    </p>        
    ';  
}



add_action('save_post', 'wpstream_free_product_update_post', 1, 2);
function wpstream_free_product_update_post($post_id,$post){
    
    if(!is_object($post) || !isset($post->post_type)) {
        return;
    }
    
    if($post->post_type!='wpstream_product'){
        return;    
    }
    
     
    $allowed_keys=array(
        'wpstream_product_type',
        'wpstream_free_video'
     );
    
    $allowed_html=array();
    
    foreach ($_POST as $key => $value) {
        if( !is_array ($value) ){
            if (in_array ($key, $allowed_keys)) {
                $postmeta = wp_kses ( $value,$allowed_html ); 
                update_post_meta($post_id, sanitize_key($key), $postmeta );
            }
        }       
    }
}





function wpstream_insert_player($content){
    global  $post;

    

    $live_event_stream_name =    esc_html(get_post_meta($post->ID, 'live_event_stream_name', true));

    if ( is_singular('wpstream_product') && in_the_loop() ) {
        $wpstream_product_type =    esc_html(get_post_meta($post->ID, 'wpstream_product_type', true));
        if($wpstream_product_type==1){
            ob_start();
                $player='';
                wpstream_live_event_player($post->ID);
                $player =ob_get_contents();
            ob_end_clean();
            $content = '<div class="free_wpstream_player wpstream_live_stream">'.$player.'</div>'.$content;
        }else if($wpstream_product_type==2){
            ob_start();
                $player='';
                $video_path =    esc_html(get_post_meta($post->ID, 'wpstream_free_video', true));
                wpstream_video_on_demand_player($post->ID);
                $player =ob_get_contents();
            ob_end_clean();
            $content = '<div class="free_wpstream_player wpstream_video_on_demand">'.$player.'</div>'.$content;
        }

    remove_filter( 'the_content', 'wpstream_insert_player');

    }

    return $content;
}
add_filter( 'the_content', 'wpstream_insert_player' );      
?>