<?php
/**
 * Plugin Name: WpStream
 * Plugin URI: wpstream.net
 * Description: WpStream is a wordpress plugin to help you stream & monetize media content.
 * Version: 1.5.2
 * Author: wpstream.net
 * Author URI: https://wpstream.net
 * Developer: WpStream
 * Developer URI: https://wpstream.net
 * Text Domain: wpstream
 * Domain Path: /languages
 * * Copyright: © 2017 WpStream
 */


define('WPSTREAM_CLUBLINK', 'wpstream.net');
define('WPSTREAM_CLUBLINKSSL', 'https');
define('WPSTREAM_PLUGIN_URL',  plugins_url() );
define('WPSTREAM_PLUGIN_DIR_URL',  plugin_dir_url(__FILE__) );
define('WPSTREAM_PLUGIN_PATH',  plugin_dir_path(__FILE__) );
define('WPSTREAM_PLUGIN_BASE',  plugin_basename(__FILE__) );

require_once    ('main.php');
require_once    ('libs/api_functions.php');
require_once    ('libs/plugin-admin.php');
require_once    ('libs/product_types.php');
require_once    ('libs/wpstream_free_product_types.php');
require_once    ('libs/shortcodes.php');



function wpstream_install(){
    flush_rewrite_rules();
}

register_activation_hook( __FILE__, 'wpstream_install' );




function wpstream_deactivation(){
    delete_option('wp_estate_token_expire');
    delete_option('wp_estate_curent_token');
    delete_option('wpstream_api_key');
    delete_option('wpstream_api_secret_key');
    delete_option('wpstream_api_username');
    delete_option('wpstream_api_password');

    flush_rewrite_rules();
}
register_deactivation_hook( __FILE__, 'wpstream_deactivation' );


wpstream_main_start();



function wpstream_admin_notice(){
    if ( !in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
        print '<div class="notice  notice-error is-dismissible">
            <p>'.__( 'WpStream Pay Per View / Subscription  mode works only with WooCommerce - If you want to charge money for your live events or videos you need to activate WooCommerce plugin', 'wpestate' ).'</p>
        </div>';
    }
    if( !in_array  ('curl', get_loaded_extensions())) {
        print '<div class="notice  notice-error is-dismissible">
            <p>'.__( 'The php CURL library is not enabled on your server. WpStream plugin needs this library in order to work. Please address this issue with your hosting provider.', 'wpestate' ).'</p>
        </div>';
    }
    
    
}
add_action( 'admin_notices', 'wpstream_admin_notice' );



function wpstream_enqueue_styles() {
    wp_enqueue_style('wpstream-style',          WPSTREAM_PLUGIN_DIR_URL .'/wpstream_style.css' );
    wp_enqueue_style('video-js.min',            WPSTREAM_PLUGIN_DIR_URL.'/css/video-js.min.css', array(), '1.0', 'all');
    wp_enqueue_script('video.min',              WPSTREAM_PLUGIN_DIR_URL.'js/video.min.js',array(), '1.0', false);
    wp_enqueue_script('video.min',              WPSTREAM_PLUGIN_DIR_URL.'js/video.min.js',array(), '1.0', false);
    wp_enqueue_script('videojs-contrib-hls',    WPSTREAM_PLUGIN_DIR_URL.'js/videojs-contrib-hls.min.js',array(), '1.0', false);
}




function wpstream_enqueue_styles_admin(){
    wp_enqueue_script("jquery-ui-slider");
    wp_enqueue_script("jquery-ui-datepicker");  
    wp_enqueue_style ('admin-css',                WPSTREAM_PLUGIN_DIR_URL.'/css/admin_style.css', array(), '1.0', 'all'); 
    wp_enqueue_script('wpstream-admin-control',   WPSTREAM_PLUGIN_DIR_URL.'js/admin_control.js',array(), '1.0', true);  
    wp_localize_script('wpstream-admin-control', 'wpstream_admin_control_vars', 
        array( 
            'admin_url'             =>  get_admin_url(),
            'loading_url'           =>  WPSTREAM_PLUGIN_DIR_URL.'/img/loading.gif',
        ));
}





function wpstream_my_custom_endpoints() {
    add_rewrite_endpoint( 'video-list', EP_ROOT | EP_PAGES );
    add_rewrite_endpoint( 'event-list', EP_ROOT | EP_PAGES );
}



function wpstream_my_custom_query_vars( $vars ) {
    $vars[] = 'video-list';
    $vars[] = 'event-list';
    return $vars;
}



function wpstream_custom_flush_rewrite_rules() {
    flush_rewrite_rules();
}



function wpstream_custom_my_account_menu_items( $items ) {
    $items = array(
        'dashboard'         => __( 'Dashboard', 'woocommerce' ),
        'orders'            => __( 'Orders', 'woocommerce' ),
        'edit-address'      => __( 'Addresses', 'woocommerce' ),
        'edit-account'      => __( 'Edit Account', 'woocommerce' ), 
        'event-list'        => __( 'Events', 'wpstream' ),
        'video-list'        => __( 'Videos', 'wpstream' ),
        'customer-logout'   => __( 'Logout', 'woocommerce' ),
    );
    return $items;
}


function wpstream_custom_endpoint_content_event_list() {
    include 'woocommerce/myaccount/event_list.php';
}



function wpstream_custom_endpoint_video_list() {
    include 'woocommerce/myaccount/video_list.php';
}




function wpstream_user_logged_in_product_already_bought($from_sh_id='') {

    if ( is_user_logged_in() ) {
        global $product;
        $current_user   =       wp_get_current_user();
        $product_id     =       $product->get_id();


        if ( wc_customer_bought_product( $current_user->user_email, $current_user->ID, $product_id) || ( function_exists('wcs_user_has_subscription') && wcs_user_has_subscription( $current_user->ID, $product_id ,'active') ) ){


            echo '<div class="wpstream_player_wrapper"><div class="wpstream_player_container">';

           $is_subscription_live_event =   esc_html(get_post_meta($product_id,'_subscript_live_event',true));
           $term_list                  =   wp_get_post_terms($product_id, 'product_type');

            if( $term_list[0]->name=='live_stream' || ($term_list[0]->name=='subscription' && $is_subscription_live_event=='yes' )  ){
                wpstream_live_event_player($product_id);
            }else if( $term_list[0]->name=='video_on_demand'  || ($term_list[0]->name=='subscription' && $is_subscription_live_event=='no' ) ){
                wpstream_video_on_demand_player($product_id);
            }

        }else{
            echo '<div class="wpstream_player_wrapper no_buy"><div class="wpstream_player_container">';
            echo '<div class="wpstream_notice">'.__('You did not buy this product!','wpstream').'</div>';
        }

        echo '</div></div>';
    }
}


function wpstream_live_event_player($product_id){
    $live_event_uri     = get_post_meta($product_id,'live_event_uri',true); 
    $thumb_id           = get_post_thumbnail_id($product_id);
    $thumb              = wp_get_attachment_image_src($thumb_id,'small');
    $live_event_uri_final='';
    if(isset($live_event_uri) ){
        $live_event_uri_aray    =   explode('/wpstream/', $live_event_uri);
        $part1                  =   str_replace('rtmp', 'https',$live_event_uri_aray[0]);
        $part2_array            =   explode('?auth=', $live_event_uri_aray[1]);
        $live_event_uri_final   =   $part1.'/hls/'.$part2_array[0].'.m3u8';
    }
    echo'<video id="wpstream-video"  class="video-js vjs-default-skin  vjs-16-9" controls>
    <source
        src="'.$live_event_uri_final.'"
        type="application/x-mpegURL">
    </video>

    <script>
        var player = videojs(\'wpstream-video\');
        player.play();
    </script>';

}



function wpstream_video_on_demand_player($product_id){
    $thumb_id           =   get_post_thumbnail_id($product_id);
    $thumb              =   wp_get_attachment_image_src($thumb_id,'small');
    $video_path         =   get_post_meta($product_id,'_movie_url',true); 

    if(get_post_type($product_id)=='wpstream_product'){
        $video_path =    esc_html(get_post_meta($product_id, 'wpstream_free_video', true));
    }


    $username           =   esc_html ( get_option('wpstream_api_username','') );

    if(strpos($username,'@')!=false){
        $username_array= explode('@', $username);
        $username=$username_array[0];
    }

    $video_path_final   =   'https://vod.streamer.wpstream.net/'.$username.'/'.$video_path.'/index.m3u8?'.get_site_url();
    if(!is_ssl()){
        $video_path_final   =   'http://vod.streamer.wpstream.net/'.$username.'/'.$video_path.'/index.m3u8?'.get_site_url(); 
    }

    echo'<video id="my-video" class="video-js vjs-default-skin  vjs-16-9" controls preload="auto"
        poster="'.$thumb[0].'" data-setup="{}">

          <source src="'.trim($video_path_final).'"  type="application/x-mpegURL">
          <p class="vjs-no-js">
            To view this video please enable JavaScript, and consider upgrading to a web browser that
            <a href="http://videojs.com/html5-video-support/" target="_blank">supports HTML5 video</a>
          </p>
        </video>';

}



add_filter('display_post_states', 'wpstream_custom_post_states',10,2);

function wpstream_custom_post_states( $states, $post ) { 
    $title =strtolower( get_the_title($post->ID));
    if ( ( 'page' == get_post_type( $post->ID ) ) && ( $title ==='userkey'  ||  $title ==='vodkey'  ||  $title ==='wpstream'   )) {
        $states[] = __('by WpStream - do not delete','wpstream'); 
    } 

    return $states;
} 






function wpstream_custom_rewrite_tag() {
    add_rewrite_tag('%streamname%', '([^&]+)');
    add_rewrite_tag('%streamname2%', '([^&]+)');
    add_rewrite_tag('%variety%', '([^&]+)');
    add_rewrite_tag('%userkey%', '([^&]+)');
    add_rewrite_tag('%streamvod%', '([^&]+)');
}
add_action('init', 'wpstream_custom_rewrite_tag', 10, 0);



function wpstream_custom_rewrite_rule() {
    $page           =   get_page_by_title( 'WpStream' );
    $page_user_key  =   get_page_by_title( 'Userkey' );
    $page_vod_key   =   get_page_by_title( 'Vodkey' );


    if( isset($page->ID)  ){
        add_rewrite_rule('^keys/([^/]*/?)','index.php?page_id='.$page->ID.'&streamname=$matches[1]','top');
    }

    if(  isset($page_vod_key->ID)  ){ // is wod-key=page-template
        add_rewrite_rule('^keys1/([^/]*)/([^/]*)/?','index.php?page_id='.$page_vod_key->ID.'&streamname=$matches[1]&streamname2=$matches[2]','top');
    }

    if(  isset($page_user_key->ID)  ){//us user-key-page-temaplte
        add_rewrite_rule('^keys2/([^/]*)/([^/]*)/?','index.php?page_id='.$page_user_key->ID.'&streamname=$matches[1]&streamname2=$matches[2]','top');
    }

    flush_rewrite_rules();

}
add_action('init', 'wpstream_custom_rewrite_rule', 10, 0);
  




function wpstream_live_page_template( $page_template ){
    if ( is_page( 'wpstream' ) ) {
        $page_template = dirname( __FILE__ ) . '/live_stream_checker.php';
    }
    return $page_template;
}
add_filter( 'page_template', 'wpstream_live_page_template' );




function wpstream_userkey_page_template( $page_template ){
    if ( is_page( 'Userkey' ) ) {
        $page_template = dirname( __FILE__ ) . '/user-key-page-template.php';
    }
    return $page_template;
}
add_filter( 'page_template', 'wpstream_userkey_page_template' );





function wpstream_vodkey_page_template( $page_template ){
    if ( is_page( 'vodkey' ) ) {
        $page_template = dirname( __FILE__ ) . '/vod-key-page-template.php';
    }
    return $page_template;
}
add_filter( 'page_template', 'wpstream_vodkey_page_template' );


 
function wpstream_remove_gallery_and_product_images() {
    if ( is_product() ) {
        remove_action( 'woocommerce_before_single_product_summary', 'woocommerce_show_product_images', 20 );
    }
}




function wpstream_cors_check_and_response(){
    if ($_SERVER['REQUEST_METHOD'] == "OPTIONS") {
        header('Access-Control-Allow-Methods: POST, GET');
        header('Access-Control-Allow-Headers: Authorization');
        header('Access-Control-Max-Age: 1');  //1728000
        header("Content-Length: 0");
        header("Content-Type: text/plain charset=UTF-8");
        exit(0);
    }
}

add_action('wo_before_api', 'wpstream_cors_check_and_response');


